#!/usr/bin/env python3
"""
main (GLaDOS)
=============

Description
-----------
Create a bot's instance and manages it.
"""

import logging
import re
from irc_api import api


import glados_cmnds as gv4_cmnds
import fun_cmnds as fcmnds
from secrets import USER, PASSWORD


LOG_FORMAT = "%(asctime)s [%(levelname)s] <%(filename)s> %(funcName)s: %(message)s"
logging.basicConfig(format=LOG_FORMAT, level=logging.DEBUG)


glados = api.Bot(
    (USER, PASSWORD),
    ('irc.planet-casio.com', 6697),
    ["#glados"],
    gv4_cmnds, fcmnds,
    prefix="!",
    limit=50
)


glados.start()
